#define WORK_MODE 0

//	functor
#if (WORK_MODE==0)
#include <iostream>

class Add {
public:
	int operator()(int a, int b) { return a + b; };
};

int main()
{
	std::cout << "1 + 2 = " << Add()(1, 2) << std::endl;
	return 0;
}
//	C++ Լ  

//	lambda
#elif (WORK_MODE == 1)
#include <iostream>

int main()
{
	auto Add = [=](int a, int b)->int { return a + b;  };
	std::cout << "1 + 2 = " << Add(1, 2) << std::endl;
	return 0;
}
//	auto ڵ带 ־ ȣ


//	function
#elif (WORK_MODE == 2)
#include <iostream>
#include <functional>

using namespace std;

int add(int a, int b) { return a + b; }

int main()
{
	auto add0 = function<int(int, int)>(add);
	auto add1 = function<int(int, int)>([](int a, int b) -> int { return a + b; });
	auto add2 = [](int a, int b) -> int { return a + b; };

	cout << add0(1, 2) << endl;
	cout << add1(1, 2) << endl;
	cout << add2(1, 2) << endl;
	return 0;
}
//	  ϴ   

//	vector/array/foreach
#elif (WORK_MODE == 3)
#include <iostream>
#include <vector>
#include <array>
#include <numeric>

using namespace std;
int main()
{
	vector<int> v(5);
	array <int, 5> a = { 0, 1, 2, 3, 4 };
	iota(begin(v), end(v), 0);	//	set v : 0~5

	int v_sum = 0;
	int a_sum = 0;

	for_each(v.begin(), v.end(), [&](int n) { v_sum += n; });
	for_each(a.begin(), a.end(), [&](int n) { a_sum += n; });

	cout << "vector : 0 + 1 + 2 + 3 + 4 = " << v_sum << endl;
	cout << "array : 0 + 1 + 2 + 3 + 4 = " << a_sum << endl;
}
//	for_each ̿Ͽ vector array ε͸ ϴ 
#endif
